-- Tries to measure the average number of polygons drawn every second.
-- The qoutient (polygons/second) will drop as the resolution goes up. This is because I let
-- the X and Y coordinates vary over the entire screen. So the maximum area of a triangle
-- in 320*200 resolution is 320*200/2 pixels, while in 800*600 it would be 800*600/2 pixels.


without warning

include render.e
include stuff.e
include colors.e
include bmp.e


atom vscreen,mix
atom t1,t2
sequence times,coords,bmp
integer XDIM,YDIM,XCENTRE,YCENTRE,BPP,key
integer ITERATIONS

puts(1,"Simple polygon-filling benchmark program\n")
puts(1,"By Mic, 1999/2000\n")
puts(1,"Choose a graphics mode:\n")
puts(1," [1] 320*200  (8-bit)\n [2] 640*480  (8-bit)\n [3] 800*600  (8-bit)\n [4] 1024*768 (8-bit)\n")
puts(1," [5] 320*200  (15-bit)\n [6] 640*480  (15-bit)\n [7] 800*600  (15-bit)\n [8] 1024*768 (15-bit)\n")
puts(1," [9] 320*200  (24-bit)\n [a] 640*480  (24-bit)\n [b] 800*600  (24-bit)\n [c] 1024*768 (24-bit)\n [0] Abort mission\n\n")
key=0
while ((key<'0') or (key>'9')) and ((key<'a') or (key>'c')) do
 key=get_key()
end while
if key='0' then
 abort(0)
elsif key='1' then
 XDIM=320
 YDIM=200
 XCENTRE=160
 YCENTRE=100
 ITERATIONS=18000
 BPP=8
elsif key='2' then
 XDIM=640
 YDIM=480
 XCENTRE=320
 YCENTRE=240
 ITERATIONS=9000
 BPP=8
elsif key='3' then
 XDIM=800
 YDIM=600
 XCENTRE=400
 YCENTRE=300
 ITERATIONS=7500
 BPP=8
elsif key='4' then
 XDIM=1024
 YDIM=768
 XCENTRE=512
 YCENTRE=384
 ITERATIONS=5000
 BPP=8
elsif key='5' then
 XDIM=320
 YDIM=200
 XCENTRE=160
 YCENTRE=100
 ITERATIONS=8000
 BPP=15
elsif key='6' then
 XDIM=640
 YDIM=480
 XCENTRE=320
 YCENTRE=240
 ITERATIONS=6000
 BPP=15
elsif key='7' then
 XDIM=800
 YDIM=600
 XCENTRE=400
 YCENTRE=300
 ITERATIONS=4500
 BPP=15
elsif key='8' then
 XDIM=1024
 YDIM=768
 XCENTRE=512
 YCENTRE=384
 ITERATIONS=3000
 BPP=15
elsif key='9' then
 XDIM=320
 YDIM=200
 XCENTRE=160
 YCENTRE=100
 ITERATIONS=6500
 BPP=24
elsif key='a' then
 XDIM=640
 YDIM=480
 XCENTRE=320
 YCENTRE=240
 ITERATIONS=4400
 BPP=24
elsif key='b' then
 XDIM=800
 YDIM=600
 XCENTRE=400
 YCENTRE=300
 ITERATIONS=2800
 BPP=24
elsif key='c' then
 XDIM=1024
 YDIM=768
 XCENTRE=512
 YCENTRE=384
 ITERATIONS=1500
 BPP=24
end if

if render_mode(XDIM,YDIM,BPP) then end if

mix=0

clear_screen()
puts(1,"Loading texture\n")
bmp=load_bmp("sdasuka3.bmp")
if BPP=15 then
 bmp=convert_image(bmp[2..5],15,8)
elsif BPP=24 then
 bmp=convert_image(bmp[2..5],24,8)
else
 puts(1,"Creating mixtable\n")
 mix=create_mixtable(floor(bmp[5]/4),floor(bmp[5]/4),floor(bmp[5]/4)) 
 render_mixtable(mix)
 bmp=bmp[2..4]
end if


times={0,0,0,0,0}
vscreen=allocate(XDIM*YDIM*floor((BPP+1)/8))
if vscreen=0 then
 puts(2,"Doh! Unable to allocate memory for virtual screen!\n")
 abort(1)
end if

puts(1,"\nTiming performance...\n\n")

puts(1,"Timing asm_tri_ex()")
t1=time()
for i=1 to ITERATIONS do
 coords={{rand(XDIM),rand(YCENTRE-1)},{rand(XCENTRE-1)+XCENTRE,rand(YCENTRE-1)+YCENTRE},{rand(XCENTRE-1),rand(YCENTRE-1)+YCENTRE}}
 asm_tri_exx(coords,4,vscreen)
end for
t2=time()
if (t2-t1)!=0 then
 times[1]=ITERATIONS/(t2-t1)
else
 times[1]=ITERATIONS
end if
puts(1,"  [DONE]\n")



puts(1,"Timing asm_gouraudtri_ex()")
t1=time()
for i=1 to ITERATIONS do
 coords={{rand(XDIM),rand(YCENTRE-1)},{rand(XCENTRE-1)+XCENTRE,rand(YCENTRE-1)+YCENTRE},{rand(XCENTRE-1),rand(YCENTRE-1)+YCENTRE}}
 asm_gouraudtri_ex(coords,{4,14,24,45},vscreen)
end for
t2=time()
if (t2-t1)!=0 then
 times[2]=ITERATIONS/(t2-t1)
else
 times[2]=ITERATIONS
end if
puts(1,"  [DONE]\n")


puts(1,"Timing asm_texturetri_ex(REGULAR)")
t1=time()
for i=1 to (ITERATIONS/2) do
 coords={{rand(XDIM),rand(YCENTRE-1)},{rand(XCENTRE-1)+XCENTRE,rand(YCENTRE-1)+YCENTRE},{rand(XCENTRE-1),rand(YCENTRE-1)+YCENTRE}}
 asm_texturetri_ex(coords,{{0,0},{255,255},{0,255}},bmp[1],REGULAR,vscreen)
end for
t2=time()
if (t2-t1)!=0 then
 times[3]=(ITERATIONS/2)/(t2-t1)
else
 times[3]=(ITERATIONS/2)
end if
puts(1,"  [DONE]\n")


puts(1,"Timing asm_texturetri_ex(MIXED)")
t1=time()
for i=1 to (ITERATIONS/2) do
 coords={{rand(XDIM),rand(YCENTRE-1)},{rand(XCENTRE-1)+XCENTRE,rand(YCENTRE-1)+YCENTRE},{rand(XCENTRE-1),rand(YCENTRE-1)+YCENTRE}}
 asm_texturetri_ex(coords,{{0,0},{255,255},{0,255}},bmp[1],MIXED,vscreen)
end for
t2=time()
if (t2-t1)!=0 then
 times[4]=(ITERATIONS/2)/(t2-t1)
else
 times[4]=(ITERATIONS/2)
end if
puts(1,"  [DONE]\n")

puts(1,"Timing asm_texturetri_ex(TILED)")
t1=time()
for i=1 to (ITERATIONS/2) do
 coords={{rand(XDIM),rand(YCENTRE-1)},{rand(XCENTRE-1)+XCENTRE,rand(YCENTRE-1)+YCENTRE},{rand(XCENTRE-1),rand(YCENTRE-1)+YCENTRE}}
 asm_texturetri_ex(coords,{{0,0},{255,255},{0,255}},bmp[1],TILED,vscreen)
end for
t2=time()
if (t2-t1)!=0 then
 times[5]=(ITERATIONS/2)/(t2-t1)
else
 times[5]=(ITERATIONS/2)
end if
puts(1,"  [DONE]\n")



clear_screen()
puts(1,"Triangles per second:\n")
printf(1," Flat:               %d\n",times[1])
printf(1," Gouraud shaded:     %d\n",times[2])
printf(1," Textured (regular): %d\n",times[3])
printf(1," Textured (mixed):   %d\n",times[4])
printf(1," Textured (tiled):   %d\n",times[5])
printf(1,"\n(graphics mode: %d*%d %d-bit)\n",{XDIM,YDIM,BPP})

free(bmp[1])
free(vscreen)
if mix then free(mix) end if