--*** Texture-mapped cube ***--
--**   By Mic, 1999/2000  **--


without warning
without type_check

include render.e
include stuff.e
include 3dmath.e
include vesa20.e
include bmp.e
include colors.e
include graphics.e


sequence points,points2,faces,order,zNormals
sequence tcoords
sequence v,dv	
integer XDIM,YDIM,XCENTRE,YCENTRE,BPP,key
integer SIZE
integer wait_retrace,map_method
atom vscreen,texture,mix
atom time1,time2,frames
sequence img,tiled,pal

points2={
 {-1,-1,-1},
 {1,-1,-1},
 {1,1,-1},
 {-1,1,-1},
 {-1,-1,1},
 {1,-1,1},
 {1,1,1},
 {-1,1,1}
}

wait_retrace=1
puts(1,"Texture-mapped cube for Euphoria 2.0+\n")
puts(1,"By Mic, 1999/2000\n\n")
puts(1,"Choose a graphics mode:\n")
puts(1," [1] 320*240   (8-bit)      [7] 800*600   (16-bit)\n [2] 640*480   (8-bit)      [8] 1024*768  (16-bit)\n")
puts(1," [3] 800*600   (8-bit)      [9] 320*240   (24-bit)\n [4] 1024*768  (8-bit)      [a] 640*480   (24-bit)\n")
puts(1," [5] 320*240   (16-bit)     [b] 800*600   (24-bit)\n [6] 640*480   (16-bit)     [c] 1024*768  (24-bit)\n [0] Abort mission\n")
puts(1,"Vertical retrace: ON  ([+]=ON [-]=OFF)\n")
puts(1,"\n\nDuring the demonstation:\n")
puts(1," [r] Use regular mapping\n [t] Use tiled mapping (faster)\n [m] Use transparent mapping\n")
puts(1," [-] Zoom in\n [+] Zoom out\n [Esc] Exit\n")
key=0
while ((key<'0') or (key>'9')) and ((key<'a') or (key>'c')) do
 key=get_key()
 if key='+' then
  position(12,19)
  puts(1,"ON ")
  wait_retrace=1
 elsif key='-' then
  position(12,19)
  puts(1,"OFF")
  wait_retrace=0
 end if  
end while
clear_screen()

if key='0' then
 abort(0)
elsif key='1' then
 XDIM=320
 YDIM=240
 XCENTRE=160
 YCENTRE=120
 SIZE=49
 BPP=8
elsif key='2' then
 XDIM=640
 YDIM=480
 XCENTRE=320
 YCENTRE=240
 SIZE=70
 BPP=8
elsif key='3' then
 XDIM=800
 YDIM=600
 XCENTRE=400
 YCENTRE=300
 SIZE=75
 BPP=8
elsif key='4' then
 XDIM=1024
 YDIM=768
 XCENTRE=512
 YCENTRE=384
 SIZE=75
 BPP=8
elsif key='5' then
 XDIM=320
 YDIM=240
 XCENTRE=160
 YCENTRE=120
 SIZE=49
 BPP=16
elsif key='6' then
 XDIM=640
 YDIM=480
 XCENTRE=320
 YCENTRE=240
 SIZE=70
 BPP=16
elsif key='7' then
 XDIM=800
 YDIM=600
 XCENTRE=400
 YCENTRE=300
 SIZE=75
 BPP=16
elsif key='8' then
 XDIM=1024
 YDIM=768
 XCENTRE=512
 YCENTRE=384
 SIZE=75
 BPP=16
elsif key='9' then
 XDIM=320
 YDIM=240
 XCENTRE=160
 YCENTRE=120
 SIZE=49
 BPP=24
elsif key='a' then
 XDIM=640
 YDIM=480
 XCENTRE=320
 YCENTRE=240
 SIZE=70
 BPP=24
elsif key='b' then
 XDIM=800
 YDIM=600
 XCENTRE=400
 YCENTRE=300
 SIZE=75
 BPP=24
elsif key='c' then
 XDIM=1024
 YDIM=768
 XCENTRE=512
 YCENTRE=384
 SIZE=75
 BPP=24
end if

camX=XCENTRE	--|
camY=YCENTRE	--| point camera towards the center of the screen	

points2=points2*(SIZE-9)
SIZE=SIZE*2

mix=0

puts(1,"Initializing...\n")
--** Load the texture **--
if BPP=8 then
 puts(1,"Loading texture\n")
 img=load_bmp("sdasuka3.bmp")
 tiled=load_bmp("sdasuka3.bmp")
 pal=floor(img[5]/4)
 pal[1]={0,0,0}
 puts(1,"Creating mixtable\n")
 mix=create_mixtable(pal,pal,pal)
 render_mixtable(mix)
 img=img[2..4]
 tiled=tiled[2..4]
 --** texture-coordinates for each of the six faces **--
 tcoords={
  {{0,0},{130,0},{130,195},{0,195}},
  {{0,0},{130,0},{130,195},{0,195}},
  {{0,0},{130,0},{130,195},{0,195}},
  {{130,0},{255,0},{255,195},{130,195}},
  {{130,0},{255,0},{255,195},{130,195}},
  {{130,0},{255,0},{255,195},{130,195}}
 }
else		--BPP=16 or BPP=24
 puts(1,"Loading texture\n")
 img=load_bmp("colorful.bmp")
 tiled=load_bmp("colorful.bmp")
 if BPP=16 then
  puts(1,"Converting texture\n")
  img=convert_image(img[2..4],16,24)
  tiled=convert_image(tiled[2..4],16,24)
 else		--BPP=24
  img=img[2..4]
  tiled=tiled[2..4]
 end if
 --** texture-coordinates for each of the six faces **--
 tcoords={
  {{0,0},{63,0},{63,63},{0,63}},
  {{0,64},{63,64},{63,127},{0,127}},
  {{64,0},{127,0},{127,63},{64,63}},
  {{128,0},{191,0},{191,63},{128,63}},
  {{192,0},{255,0},{255,63},{192,63}},
  {{64,64},{127,64},{127,127},{64,127}}
 }
end if

puts(1,"Tiling texture\n\n")
tiled=tile_texture(tiled,BPP)

--** set graphics mode **--
if vesa_mode(XDIM,YDIM,BPP) then
 puts(2,"Doh! Unable to set graphics mode!\n")
 puts(2,"Possible reasons:\n * No VESA driver installed.\n * Your videocard suck..\n")
 abort(1)
end if
if mode_type=BANKED then
 puts(2,"Doh! Unable to get a linear framebuffer!\n")
 abort(1) 
end if
if render_mode(XDIM,YDIM,BPP) then end if

vscreen=allocate(XDIM*YDIM*(BPP/8))
if vscreen<=0 then
 puts(2,"Doh! Unable to allocate memory for virtual screen!\n")
 abort(1)
end if
cls(vscreen,0)


if BPP=8 then set_pal(pal) end if

v={1,1,1}
dv={2,2,2}
frames=0
map_method=REGULAR
texture=img[1]
 
time1=time()
key=0
while key!=27 do
key=get_key()
 clear_area(vscreen,0,{{XCENTRE-SIZE,YCENTRE-SIZE},{XCENTRE+SIZE,YCENTRE+SIZE}})
 points=rotate(points2,{1,1,1},v)
  faces={
  points[1..4],
  points[5..8],
  {points[1],points[2],points[6],points[5]},
  {points[6],points[2],points[3],points[7]},
  {points[4],points[3],points[7],points[8]},
  {points[1],points[5],points[8],points[4]}  
 }
 --** Get the z-normals of the faces **--
 zNormals=get_quad_zNormal(faces) 
 order=sort_faces(faces)
 --faces=get_screen_xy({XCENTRE,YCENTRE},faces)
 faces=GetScreenXY(faces)
 for i=1 to 6 do
  --** Is the face visible ? **--
  if (map_method!=MIXED) then
   if (zNormals[order[i]]>=0) then
    asm_texturequad_ex(faces[order[i]],tcoords[order[i]],texture,map_method,vscreen) --only draw faces pointing towards viewer
   end if
  else
   asm_texturequad_ex(faces[order[i]],tcoords[order[i]],texture,map_method,vscreen)  --draw every face
  end if
 end for
 if wait_retrace then wait_vrt() end if
 single_copy(screen_copy, {vscreen, video_mem, XDIM*(BPP/8),YDIM, XDIM*(BPP/8), bytes_per_line})
 frames=frames+1
 v=v+dv
 for i=1 to 3 do
  if v[i]>=361 then
   v[i]=v[i]-360
  end if
  if v[i]<1 then
   v[i]=360+v[i]
  end if
 end for
 --** Randomize the rotation **--
 if rand(150)=1 then
  dv=rand({6,6,6})-3
 end if
 if key='+' then
  camZ=camZ-10
 elsif key='-' then
  camZ=camZ+10
 elsif key='r' then
  map_method=REGULAR
  texture=img[1]
 elsif key='m' then
  map_method=MIXED
  texture=img[1]
 elsif key='t' then
  map_method=TILED
  texture=tiled[1]
 end if
end while
time2=time()


--shut_down()
if graphics_mode(-1) then end if
free(vscreen)
free(img[1])
free(tiled[1])
if mix then free(mix) end if

printf(1,"%d frames per second.\n",floor(frames/(time2-time1)))
